<%@ page import="com.ether.WebHelper" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>

<script type="text/javascript">

var InterfaceStatistics = Class.create( {
    initialize: function()
    {
        /** *********** CONTAINERS *********** **/
        this.parent = $( "#containerMiddle" );
        this.containerMenu = $( "#menuLogo" );
        this.containerErrors = $( "#errors" );

        /** *********** VARIABLES *********** **/
        this.language = '<spring:message code="language"/>';
        this.webmaster = "<%=WebHelper.getProperty(request, "mail.webmaster")%>";
        this.jSONUser = <%=WebHelper.getJSONUser( request )%> ? <%=WebHelper.getJSONUser( request )%> : false;
        this.logoSizeSmall = 30;
        this.logoSizeBig = 50;

        this.projectsArray = [
            {id:"ETHER", img:"logo_Ether_50.jpg", top:"-16px", left:"125px"},
            {id:"NDACC", img:"logo_Ndacc_50.jpg", top:"1.66667px", left:"46.3334px"},
            {id:"ECCAD", img:"logo_ECCAD_50.gif", top:"39.3333px", left:"109.333px"},
            {id:"IASI", img:"logo_iasi_50.jpg", top:"-78.6667px", left:"77.6666px"},
            {id:"GOSAT", img:"logo_gosat_50.jpg", top:"-0.333328px", left:"200.667px"},
            {id:"IAGOS", img:"logo_Iagos_50.jpg", top:"36px", left:"138px"},
            {id:"TROPICO", img:"logo_tropico_50.jpg", top:"-74px", left:"45px"},
            {id:"MEGAPOLI", img:"logo_Megapoli_50.png", top:"-74.3333px", left:"15.3333px"},
            {id:"MIMOSA", img:"logo_mimosa_50.png", top:"-45.6667px", left:"76.3334px"},
            {id:"REPROBUS", img:"logo_reprobus_50.png", top:"-48px", left:"161.667px"},
            {id:"GEISA", img:"logo_geisa_50.jpg", top:"22px", left:"167.667px"},
            {id:"TAPAS", img:"logo_tapas_50.png", top:"58.3333px", left:"125px"},
            {id:"OUTREACH", img:"logo_acomida_50.jpg", top:"-77.3333px", left:"225px"},
            {id:"OMER7A", img:"logo_omer7A_50.jpg", top:"22.6667px", left:"76.3334px"},
            {id:"GIRAFE", img:"logo_girafe_50.JPG", top:"-79.6667px", left:"192.333px"},
            {id:"ARLETTY", img:"logo_arletty_50.jpg", top:"-79px", left:"161.667px"}
        ];
        this.widthInitMentionsOrCredits = $( "#mentions" ).width();

        this.xArray = ["2010-10", "2010-11", "2010-12", "2011-01", "2011-02"];
        this.yArray = [0, 10, 30, 50, 100];

        this.bindButtons();
        this.createMenuLogo();

        $( document ).ready( jQuery.proxy( function()
        {
            $( ".containerToDrag" ).draggable();
            // Menu
            this.animateMenuLogos();
            this.bindMenuLogos();
            this.createRightSlide();

            if( !this.jSONUser )
                this.onClickHelp();
            else
                this.handleLogin();
        }, this ) );
    },


    // CREATES AND BINDS ********************************************************
    bindButtons: function()
    {
        $( "#home_button" ).bind( "dblclick", this.onClickHome );
        $( "#language_button" ).bind( "dblclick", jQuery.proxy( this.onClickLanguage, this ) );
        $( "#mail_button" ).bind( "dblclick", jQuery.proxy( this.onClickMail, this ) );
        $( "#help" ).bind( "click", jQuery.proxy( this.onClickHelp, this ) );
        $( "#credits" ).bind( "dblclick", jQuery.proxy( this.onClickCredits, this ) );
        $( "#mentions" ).bind( "dblclick", jQuery.proxy( this.onClickMentions, this ) );
        $( "#login_button" ).bind( "click", jQuery.proxy( this.onClickLogin, this ) );
        $( "#logout_button" ).bind( "dblclick", jQuery.proxy( this.onClickLogout, this ) );
    },

    createMenuLogo: function()
    {
        var initTop = this.projectsArray[0].top;
        var initLeft = this.projectsArray[0].left;

        jQuery.each( this.projectsArray, jQuery.proxy( function( i, logo )
        {
            var divLogo = $( document.createElement( "div" ) );
            divLogo.addClass( "divLogo containerToDrag" );
            divLogo.attr( {id:logo.id, style:"position:absolute; top:" + initTop + "; left:" + initLeft} );
            divLogo.html( '<img id="img_' + logo.id + '"src="resources/images/' + logo.img + '" width="' + this.logoSizeSmall + 'px" height="' + this.logoSizeSmall + 'px"/>' );
            this.containerMenu.append( divLogo );
        }, this ) );
    },

    createAllSlides: function()
    {
        this.leftTopSlide = new DragSlide( {id:"leftTop", parent:this.parent, width:"170", height:"200", top:"140px", left:"53px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );

        this.leftMiddleSlide = new DragSlide( {id:"leftMiddleSlide", parent:this.parent, width:"170", height:"100", top:"355px", left:"53px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );
        this.leftMiddleSlide.setTitle( '<spring:message code="statistics.data"/>' );

        this.leftBottomSlide = new DragSlide( {id:"leftBottomSlide", parent:this.parent, width:"170", height:"100", top:"470px", left:"53px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );
        this.leftBottomSlide.setTitle( '<spring:message code="statistics.duration"/>' );

        this.middleSlide = new DragSlide( {id:"middle", parent:this.parent, width:"430", height:"430", top:"140px", left:"245px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );

        this.rightSlide = new DragSlide( {id:"right", parent:this.parent, width:"200", height:"270", top:"210px", left:"698px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );

        this.rightLoginSlide = new DragSlide( {id:"loginRight", parent:this.parent, width:"200", height:"25", top:"170px", left:"697px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );
    },

    createRightSlide: function()
    {
        this.rightSlide = new DragSlide( {id:"right", parent:this.parent, width:"200", height:"270", top:"210px", left:"698px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );
    },

    // REQUESTS ********************************************************
    requestChangeLocale: function()
    {
        $.ajax( {
            url: "project?methodName=setLocale&language=<spring:message code="label.language.value.to.switch"/>",
            success:function()
            {
                location.reload();
            },
            error: jQuery.proxy( this.showErrors, [this] )
        } );
    },

    requestLogin: function()
    {
        var login = $( "#loginValue" ).val();
        var pwd = $( "#pwdValue" ).val();
        $.ajax( {
            url: "project?methodName=login&login=" + login + "&pwd=" + pwd,
            dataType: 'json', // Info needed since jquery.1.7 !!
            success:jQuery.proxy( this.handleLogin, this ),
            error: jQuery.proxy( this.showErrors, [this, "489px", "566px"] )
        } );
    },

    requestLogout: function()
    {
        $.ajax( {
            url: "project?methodName=logout",
            dataType: 'json', // Info needed since jquery.1.7 !!
            success:jQuery.proxy( this.handleLogout, this ),
            error: jQuery.proxy( this.showErrors, [this] )
        } );
    },

    requestDataByLogo: function()
    {
        if( !this.selectedLogo && !this.selectedLogo.id )
            return;

        $.ajax( {
            url: "statistic?methodName=searchMainStatisticsByProject&name=" + this.selectedLogo.id,
            success:jQuery.proxy( this.handleDataByLogo, this ),
            error: jQuery.proxy( this.showLoginError, this )
        } );
    },

    // HANDLES ********************************************************
    handleDataByLogo: function( result )
    {
        this.changeLeftTopSlide();
        this.changeLeftMiddleSlide();
        this.changeLeftBottomSlide();
        this.displayVisitEvolution();
    },

    handleLogin: function( result )
    {
        this.containerErrors.empty();
        this.containerErrors.css( "visibility", "hidden" );

        if( result )
            this.jSONUser = result.jSONUser;

        $( "#loginValue" ).val( "" );
        $( "#pwdValue" ).val( "" );
        $( "#login_text" ).css( "visibility", "hidden" );
        $( "#login" ).animate( {
            top:'47px',
            left:'126px'
        }, 2000, function()
        {
        } );

        $( "#login_bg" ).animate( {
            opacity: 1,
            height:'60px',
            width:'67px'
        }, 2000, function()
        {
        } );

        $( "#login_img" ).animate( {
            top:'25px',
            left: '16px',
            width: '0',
            height: '0'
        }, 2000, jQuery.proxy( function()
        {
            // Slides
            this.parent.empty();
            this.createAllSlides();
            this.changeRightSlide();

            // User
            if( this.jSONUser.name )
                this.rightLoginSlide.setTitle( this.jSONUser.name );
            else
                this.rightLoginSlide.setTitle( '<spring:message code="label.unknown"/>' );
            $( "#logout_button" ).css( "visibility", "visible" );

            // Logo
            this.selectedLogo = $( "#ETHER" )[0];
            this.isSelectedLogoEther = true;
            this.onClickLogo();
        }, this ) );
    },

    handleLogout: function()
    {
        this.jSONUser = false;
        this.parent.empty();
        this.createRightSlide();
        this.onClickHelp();

        $( "#logout_button" ).css( "visibility", "hidden" );
        $( "#login" ).css( { zIndex:1 } ).animate( {
            top:'79px',
            left:'88px'
        }, 2000, function()
        {
        } );

        $( "#login_bg" ).animate( {
            opacity: 0.85,
            height:'500px',
            width:'500px'
        }, 2000, function()
        {
            $( "#login_text" ).css( "visibility", "visible" );
        } );

        $( "#login_img" ).animate( {
            top:'103px',
            left: '148px',
            width: '30px',
            height: '30px'
        }, 2000, function()
        {
        } );
    },

    // EVENTS ********************************************************
    onClickHome: function()
    {
        location.reload();
    },

    onClickLanguage: function()
    {
        this.requestChangeLocale();
    },

    onClickMail: function()
    {
        document.location.href = "mailto:" + this.webmaster + "?subject=[STATISTICS]";
    },

    onClickMentions: function()
    {
        if( this.widthInitMentionsOrCredits == $( "#mentions" ).width() )
            this.enlargeCreditsOrMentions( $( "#mentions" ), $( "#mentions_bg" ), $( "#mentions_text" ), $( "#mentions_title" ), "project/mentions_" + this.language + ".jsp" );
        else
            this.reduceCreditsOrMentions( $( "#mentions" ), $( "#mentions_bg" ), $( "#mentions_text" ), $( "#mentions_title" ), "project/mentions_" + this.language + ".jsp" );
    },

    onClickCredits: function()
    {
        if( this.widthInitMentionsOrCredits == $( "#credits" ).width() )
            this.enlargeCreditsOrMentions( $( "#credits" ), $( "#credits_bg" ), $( "#credits_text" ), $( "#credits_title" ), "project/credits_" + this.language + ".jsp" );
        else
            this.reduceCreditsOrMentions( $( "#credits" ), $( "#credits_bg" ), $( "#credits_text" ), $( "#credits_title" ), "project/credits_" + this.language + ".jsp" );
    },

    onClickHelp: function()
    {
        this.rightSlide.setTitle( '<spring:message code="label.help"/>' );
        this.rightSlide.setContent( "<spring:message code='label.help.content'/>" );
        if( this.jSONUser )
            var backHelpButton = new Button( {value:"<spring:message code="label.display.actions"/>", parent:this.rightSlide.getDivContent(), className: "small positive back_button", onClick:jQuery.proxy( this.changeRightSlide, this )} );
    },

    onClickLogin: function()
    {
        this.containerErrors.empty();
        this.containerErrors.css( "visibility", "hidden" );
        this.requestLogin();
    },

    onClickLogout: function()
    {
        this.requestLogout();
    },

    onClickLogo: function()
    {
        this.isSelectedLogoEther = (this.selectedLogo == $( "#ETHER" )[0]);

        if( this.jSONUser )
            this.requestDataByLogo();
        else
        {
            this.showErrors( "<spring:message code="error.connection.need"/>" );
            this.containerErrors.css( {top:"489px", left:"566px"} );
            this.containerErrors.css( "visibility", "visible" );
        }
    },

    onClickPrint: function()
    {
        var printContent = new PrintContent();
        printContent.addContent( $( "#title" ).clone() );
        printContent.addContent( this.leftTopSlide.getDivContainer().clone().animate( {'marginLeft' : "+=80px"} ) );
        printContent.addContent( this.leftMiddleSlide.getDivContainer().clone().animate( {'marginLeft' : "+=80px"} ) );
        printContent.addContent( this.leftBottomSlide.getDivContainer().clone().animate( {'marginLeft' : "+=80px"} ) );
        printContent.addContent( this.middleSlide.getDivContainer().clone().animate( {'marginLeft' : "+=120px"} ) );
        printContent.displayPrintPreview();
    },

    // OTHERS ********************************************************
    showErrors: function( result )
    {
        var context = this[0] ? this[0] : this;
        var topValue = this[1] ? this[1] : false;
        var leftValue = this[2] ? this[2] : false;
        context.containerErrors.show();
        if( result.responseText && interfaceTexts[result.responseText] )
            context.containerErrors.html( interfaceTexts[result.responseText] );
        else if( result.responseText )
            context.containerErrors.html( result.responseText );
        else
            context.containerErrors.html( result );
        if( topValue && leftValue )
            context.containerErrors.css( {top: topValue, left: leftValue} );
        context.containerErrors.css( "visibility", "visible" );
    },

    showLoginError: function( result )
    {
        this.onClickLogout();
        this.onClickLogo();
    },

    reduceCreditsOrMentions: function( div, div_bg, div_text, div_title )
    {
        div.css( { zIndex:0 } );
        div_text.css( "visibility", "hidden" );
        div.animate( {
            left: '+=500',
            top: '+=500'
        }, 2000, function()
        {
        } );
        div_bg.animate( {
            opacity: 1,
            height:'42px',
            width:this.widthInitMentionsOrCredits + 'px',
            zIndex:'0'
        }, 2000, function()
        {
            div_title.css( "visibility", "visible" );
        } );
    },

    enlargeCreditsOrMentions: function( div, div_bg, div_text, div_title, pageToLoad )
    {
        div_title.css( "visibility", "hidden" );
        div.css( { zIndex:1 } );
        div.animate( {
            left: '-=500',
            top: '-=500'
        }, 2000, function()
        {
        } );

        div_bg.animate( {
            opacity: 0.95,
            height:'500px',
            width:'500px'
        }, 2000, function()
        {
            div_text.css( "visibility", "visible" );
            div_text.load( pageToLoad );
        } );
    },

    animateMenuLogos: function()
    {
        jQuery.each( this.projectsArray, jQuery.proxy( function( i, logo )
        {
            $( "#" + logo.id ).animate( {
                top:logo.top,
                left:logo.left
            }, 5000, function()
            {
            } );
        }, this ) );
    },

    bindMenuLogos: function()
    {
        var gap = (this.logoSizeBig - this.logoSizeSmall) / 2;
        var logoSizeBig = this.logoSizeBig + "px";
        var logoSizeSmall = this.logoSizeSmall + "px";
        var gridimage;

        $( '.divLogo' ).mouseover( function( element )
        {
            gridimage = $( this ).find( 'img' ); //Define target as a variable
            gridimage.stop().animate( {
                width: logoSizeBig,
                height: logoSizeBig
            }, 150 );
            $( this ).animate( {
                top: "-=10px",
                left: "-=10px"
            }, 150 );
        } );

        $( '.divLogo' ).mouseout( function( element )
        {
            $( this ).animate( {
                top: "+=10px",
                left: "+=10px"
            }, 150 );
            gridimage.stop().animate( {
                width: logoSizeSmall,
                height:logoSizeSmall
            }, 150 );
        } );

        $( '.divLogo' ).dblclick( jQuery.proxy( function( element )
        {
            this.selectedLogo = element.currentTarget;
            this.onClickLogo();
        }, this ) );
    },

    changeLeftTopSlide: function()
    {
        this.leftTopSlide.setTitle( '<spring:message code="title"/> : ' + this.selectedLogo.id );
        this.leftTopSlide.setContent(
                "<spring:message code="statistics.online"/> : 2006/05/08<BR/>" +
                        "<span class='text1'><spring:message code="statistics.since"/> : 2009/05/08<BR/><BR/></span>" +
                        "<spring:message code="statistics.user.registered"/> : 1500<BR/>" +
                        "<spring:message code="statistics.visit"/> : 150<BR/>" );
    },

    changeLeftMiddleSlide: function()
    {
        this.leftMiddleSlide.setContent( "<spring:message code="statistics.data.download"/> : 15001<BR/><spring:message code="statistics.data.download.size"/> : 50To<BR/>" );
    },

    changeLeftBottomSlide: function()
    {
        this.leftBottomSlide.setContent( "<spring:message code="statistics.duration.total"/> : 15001''<BR/><spring:message code="statistics.duration.average"/> : 50''<BR/>" );
    },

    changeRightSlide: function()
    {
        this.rightSlide.setTitle( '<spring:message code="label.actions"/>' );
        this.rightSlide.getDivContent().empty();
        new Button( {value:"<spring:message code="statistics.visit"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayVisitEvolution, this )} );
        new Button( {value:"<spring:message code="statistics.user.registered"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayRegisteredUserEvolution, this )} );
        new Button( {value:"<spring:message code="statistics.user.connected"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayConnectedUserEvolution, this )} );
        new Button( {value:"<spring:message code="statistics.data.download"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayDownloadEvolution, this )} );
        new Button( {value:"<spring:message code="statistics.map.distribution"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayMapDistribution, this )} );
        new Button( {value:"<spring:message code="label.print"/>", parent:this.rightSlide.getDivContent(), className: "blue export_button print-preview", onClick:jQuery.proxy( this.onClickPrint, this )} );
    },

    changeMiddleSlide: function( titleEvolution, titleDistribution )
    {
        if( this.isSelectedLogoEther )
            this.middleSlide.setTitle( '<spring:message code="statistics.evolution.distribution"/> : ' + this.selectedLogo.id );
        else
            this.middleSlide.setTitle( '<spring:message code="statistics.evolution"/> : ' + this.selectedLogo.id );
        this.middleSlide.getDivContent().empty();

        var linechart = $( document.createElement( "div" ) );
        linechart.addClass( "ui-widget ui-widget-content ui-corner-all statisticsEther" );
        linechart.attr( {id:"wijlinechart"} );
        this.middleSlide.getDivContent().append( linechart );

        var donut = $( document.createElement( "div" ) );
        donut.addClass( "ui-widget ui-widget-content ui-corner-all statisticsEther" );
        donut.attr( {id:"wijpiechart"} );
        this.middleSlide.getDivContent().append( donut );

        this.createLinechart( titleEvolution );
        if( this.isSelectedLogoEther )
            this.createDonut( titleDistribution );
    },

    changeMiddleSlideForMap: function()
    {
        this.middleSlide.setTitle( '<spring:message code="statistics.map.distribution"/> : ' + this.selectedLogo.id );
        this.middleSlide.getDivContent().empty();
    },


    // STATISTICS ********************************************************
    createDonut: function( title )
    {
        $( "#wijpiechart" ).wijpiechart( {
            height: 210,
            width: 400,
            radius: 140,
            legend: { visible: true },
            hint: {
                content: function ()
                {
                    return this.data.label + " : " + Globalize.format( this.value / this.total, "p2" );
                }
            },
            header: {
                text: title
            },
            seriesList: [
                {
                    label: "MacBook Pro",
                    legendEntry: true,
                    data: 46.78,
                    offset: 0
                },
                {
                    label: "iMac",
                    legendEntry: true,
                    data: 23.18,
                    offset: 0
                },
                {
                    label: "MacBook",
                    legendEntry: true,
                    data: 20.25,
                    offset: 0
                },
                {
                    label: "Mac Pro",
                    legendEntry: true,
                    data: 5.41,
                    offset: 0
                },
                {
                    label: "Mac mini",
                    legendEntry: true,
                    data: 3.44,
                    offset: 0
                }
            ],
            seriesStyles: [
                {
                    fill: "180-rgb(195,255,0)-rgb(175,229,0)", stroke: "rgb(175,229,0)", "stroke-width": 1.5
                },
                {
                    fill: "90-rgb(142,222,67)-rgb(127,199,60)", stroke: "rgb(127,199,60)", "stroke-width": 1.5
                },
                {
                    fill: "90-rgb(106,171,167)-rgb(95,153,150)", stroke: "rgb(95,153,150)", "stroke-width": 1.5
                },
                {
                    fill: "90-rgb(70,106,133)-rgb(62,95,119)", stroke: "rgb(62,95,119)", "stroke-width": 1.5
                },
                {
                    fill: "90-rgb(166,166,166)-rgb(149,149,149)", stroke: "rgb(149,149,149)", "stroke-width": 1.5
                }
            ]
        } );
    },

    createLinechart: function( title )
    {
        $( "#wijlinechart" ).wijlinechart( {
            height: 200,
            width: 400,
            axis: {
                y: {
                    origin: 0
                }
            },
            showChartLabels: false,
            header: {
                text: title
            },
            hint: {
                content: function ()
                {
                    return this.data.lineSeries.label + '\n' + this.x + '\n' + this.y + '';
                },
                contentStyle: { "font-size": 10 },
                offsetY: -10
            },
            legend: {
                visible: false
            },
            seriesList: [
                {
                    label: "",
                    legendEntry: true,
                    data: {
                        x: this.xArray,
                        y: this.yArray
                    },
                    markers: {
                        visible: true,
                        type: "circle"
                    }
                }
            ]
        } );
    },

    displayVisitEvolution: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.evolution.visit"/>', '<spring:message code="statistics.distribution.visit"/>' );
    },

    displayRegisteredUserEvolution: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.evolution.user.registered"/>', '<spring:message code="statistics.distribution.user.registered"/>' );
    },

    displayConnectedUserEvolution: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.evolution.user.connected"/>', '<spring:message code="statistics.distribution.user.connected"/>' );
    },

    displayDownloadEvolution: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.evolution.download"/>', '<spring:message code="statistics.distribution.download"/>' );
    },

    displayMapDistribution: function()
    {
        this.changeMiddleSlideForMap();
    }

} );

</script>
